Index: trunk/src/VBox/Additions/WINNT/tools/Makefile.kmk
===================================================================
--- trunk/src/VBox/Additions/WINNT/tools/Makefile.kmk	(revision 42938)
+++ trunk/src/VBox/Additions/WINNT/tools/Makefile.kmk	(revision 42939)
@@ -21,8 +21,22 @@
 
 VBoxCertUtil_TEMPLATE = NewVBoxGuestR3Exe
-VBoxCertUtil_SOURCES = VBoxCertUtil.cpp
+VBoxCertUtil_SOURCES = \
+    VBoxCertUtil.cpp \
+    VBoxCertUtil.rc
 VBoxCertUtil_LIBS = \
     crypt32.lib
 
+#
+# The icon is configurable.
+#
+VBoxCertUtil.rc_INCS = $(VBoxCertUtil_0_OUTDIR)
+VBoxCertUtil.rc_DEPS = $(VBoxCertUtil_0_OUTDIR)/VBoxCertUtil-win-icon.rc
+VBoxCertUtil.rc_CLEAN = $(VBoxCertUtil_0_OUTDIR)/VBoxCertUtil-win-icon.rc
+
+# Icon include file.
+$$(VBoxCertUtil_0_OUTDIR)/VBoxCertUtil-win-icon.rc: $(VBOX_WINDOWS_ADDITIONS_ICON_FILE) $$(VBoxCertUtil_DEFPATH)/Makefile.kmk | $$(dir $$@)
+	$(RM) -f $@
+	$(APPEND) $@ 'IDI_VIRTUALBOX ICON DISCARDABLE "$(subst /,\\,$(VBOX_WINDOWS_ADDITIONS_ICON_FILE))"'
+
 include $(FILE_KBUILD_SUB_FOOTER)
 
Index: trunk/src/VBox/Additions/WINNT/tools/VBoxCertUtil.rc
===================================================================
--- trunk/src/VBox/Additions/WINNT/tools/VBoxCertUtil.rc	(revision 42939)
+++ trunk/src/VBox/Additions/WINNT/tools/VBoxCertUtil.rc	(revision 42939)
@@ -0,0 +1,54 @@
+/* $Id$ */
+/** @file
+ * VBoxCertUtil - Resource file containing version info and icon.
+ */
+
+/*
+ * Copyright (C) 2012 Oracle Corporation
+ *
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ */
+
+#include <windows.h>
+#include <VBox/version.h>
+#include "VBoxCertUtilResource-win.h"
+
+LANGUAGE LANG_ENGLISH, SUBLANG_ENGLISH_US
+
+VS_VERSION_INFO VERSIONINFO
+   FILEVERSION          VBOX_VERSION_MAJOR_NR,VBOX_VERSION_MINOR_NR,VBOX_VERSION_BUILD_NR,0
+   PRODUCTVERSION       VBOX_VERSION_MAJOR_NR,VBOX_VERSION_MINOR_NR,VBOX_VERSION_BUILD_NR,0
+   FILEFLAGSMASK        0x3fL
+   FILEFLAGS            0x0L
+   FILEOS               0x40004L
+   FILETYPE             0x2L
+   FILESUBTYPE          0x0L
+BEGIN
+   BLOCK "StringFileInfo"
+   BEGIN
+      BLOCK "040904b0"
+      BEGIN
+         VALUE "CompanyName",      VBOX_RC_COMPANY_NAME
+         VALUE "FileDescription",  "VirtualBox Certificate Utility\0"
+         VALUE "FileVersion",      VBOX_VERSION_MAJOR "." VBOX_VERSION_MINOR "." VBOX_VERSION_BUILD "." VBOX_SVN_REV "\0"
+         VALUE "InternalName",     "VBoxCertUtil\0"
+         VALUE "LegalCopyright",   VBOX_RC_LEGAL_COPYRIGHT
+         VALUE "OriginalFilename", "VBoxCertUtil.exe\0"
+         VALUE "ProductName",      VBOX_PRODUCT " Guest Additions\0"
+         VALUE "ProductVersion",   VBOX_VERSION_MAJOR "." VBOX_VERSION_MINOR "." VBOX_VERSION_BUILD ".r" VBOX_SVN_REV "\0"
+      END
+   END
+   BLOCK "VarFileInfo"
+   BEGIN
+      VALUE "Translation", 0x409, 1200
+   END
+END
+
+#include "VBoxCertUtil-win-icon.rc"
+
Index: trunk/src/VBox/Additions/WINNT/tools/VBoxCertUtilResource-win.h
===================================================================
--- trunk/src/VBox/Additions/WINNT/tools/VBoxCertUtilResource-win.h	(revision 42939)
+++ trunk/src/VBox/Additions/WINNT/tools/VBoxCertUtilResource-win.h	(revision 42939)
@@ -0,0 +1,19 @@
+/* $Id$ */
+/** @file
+ * VBoxService - Guest Additions Service, resource IDs.
+ */
+
+/*
+ * Copyright (C) 2006-2007 Oracle Corporation
+ *
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ */
+
+#define IDI_VIRTUALBOX 101
+