Index: trunk/src/VBox/Main/idl/comimpl.xsl
===================================================================
--- trunk/src/VBox/Main/idl/comimpl.xsl	(revision 43065)
+++ trunk/src/VBox/Main/idl/comimpl.xsl	(revision 43103)
@@ -14,13 +14,13 @@
         Further extension to other interfaces is possible and anticipated.
 
-     Copyright (C) 2010-2012 Oracle Corporation
-
-     This file is part of VirtualBox Open Source Edition (OSE), as
-     available from http://www.virtualbox.org. This file is free software;
-     you can redistribute it and/or modify it under the terms of the GNU
-     General Public License (GPL) as published by the Free Software
-     Foundation, in version 2 as it comes in the "COPYING" file of the
-     VirtualBox OSE distribution. VirtualBox OSE is distributed in the
-     hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+    Copyright (C) 2010-2012 Oracle Corporation
+
+    This file is part of VirtualBox Open Source Edition (OSE), as
+    available from http://www.virtualbox.org. This file is free software;
+    you can redistribute it and/or modify it under the terms of the GNU
+    General Public License (GPL) as published by the Free Software
+    Foundation, in version 2 as it comes in the "COPYING" file of the
+    VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+    hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
 -->
 
Index: trunk/src/VBox/Main/idl/docstrip.xsl
===================================================================
--- trunk/src/VBox/Main/idl/docstrip.xsl	(revision 43065)
+++ trunk/src/VBox/Main/idl/docstrip.xsl	(revision 43103)
@@ -10,13 +10,13 @@
     VirtualBox.
 
-     Copyright (C) 2009-2010 Oracle Corporation
+    Copyright (C) 2009-2010 Oracle Corporation
 
-     This file is part of VirtualBox Open Source Edition (OSE), as
-     available from http://www.virtualbox.org. This file is free software;
-     you can redistribute it and/or modify it under the terms of the GNU
-     General Public License (GPL) as published by the Free Software
-     Foundation, in version 2 as it comes in the "COPYING" file of the
-     VirtualBox OSE distribution. VirtualBox OSE is distributed in the
-     hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+    This file is part of VirtualBox Open Source Edition (OSE), as
+    available from http://www.virtualbox.org. This file is free software;
+    you can redistribute it and/or modify it under the terms of the GNU
+    General Public License (GPL) as published by the Free Software
+    Foundation, in version 2 as it comes in the "COPYING" file of the
+    VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+    hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
 -->
 
Index: trunk/src/VBox/Main/idl/doxygen.xsl
===================================================================
--- trunk/src/VBox/Main/idl/doxygen.xsl	(revision 43065)
+++ trunk/src/VBox/Main/idl/doxygen.xsl	(revision 43103)
@@ -6,13 +6,13 @@
  *  generate the documentation using Doxygen.
 
-     Copyright (C) 2006-2010 Oracle Corporation
-
-     This file is part of VirtualBox Open Source Edition (OSE), as
-     available from http://www.virtualbox.org. This file is free software;
-     you can redistribute it and/or modify it under the terms of the GNU
-     General Public License (GPL) as published by the Free Software
-     Foundation, in version 2 as it comes in the "COPYING" file of the
-     VirtualBox OSE distribution. VirtualBox OSE is distributed in the
-     hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+    Copyright (C) 2006-2010 Oracle Corporation
+
+    This file is part of VirtualBox Open Source Edition (OSE), as
+    available from http://www.virtualbox.org. This file is free software;
+    you can redistribute it and/or modify it under the terms of the GNU
+    General Public License (GPL) as published by the Free Software
+    Foundation, in version 2 as it comes in the "COPYING" file of the
+    VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+    hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
 -->
 
Index: trunk/src/VBox/Main/idl/midl.xsl
===================================================================
--- trunk/src/VBox/Main/idl/midl.xsl	(revision 43065)
+++ trunk/src/VBox/Main/idl/midl.xsl	(revision 43103)
@@ -6,13 +6,13 @@
  *  from the generic interface definition expressed in XML.
 
-     Copyright (C) 2006-2012 Oracle Corporation
-
-     This file is part of VirtualBox Open Source Edition (OSE), as
-     available from http://www.virtualbox.org. This file is free software;
-     you can redistribute it and/or modify it under the terms of the GNU
-     General Public License (GPL) as published by the Free Software
-     Foundation, in version 2 as it comes in the "COPYING" file of the
-     VirtualBox OSE distribution. VirtualBox OSE is distributed in the
-     hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+    Copyright (C) 2006-2012 Oracle Corporation
+
+    This file is part of VirtualBox Open Source Edition (OSE), as
+    available from http://www.virtualbox.org. This file is free software;
+    you can redistribute it and/or modify it under the terms of the GNU
+    General Public License (GPL) as published by the Free Software
+    Foundation, in version 2 as it comes in the "COPYING" file of the
+    VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+    hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
 -->
 
Index: trunk/src/VBox/Main/idl/xpidl.xsl
===================================================================
--- trunk/src/VBox/Main/idl/xpidl.xsl	(revision 43065)
+++ trunk/src/VBox/Main/idl/xpidl.xsl	(revision 43103)
@@ -6,13 +6,13 @@
  *  from the generic interface definition expressed in XML.
 
-     Copyright (C) 2006-2009 Oracle Corporation
-
-     This file is part of VirtualBox Open Source Edition (OSE), as
-     available from http://www.virtualbox.org. This file is free software;
-     you can redistribute it and/or modify it under the terms of the GNU
-     General Public License (GPL) as published by the Free Software
-     Foundation, in version 2 as it comes in the "COPYING" file of the
-     VirtualBox OSE distribution. VirtualBox OSE is distributed in the
-     hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+    Copyright (C) 2006-2009 Oracle Corporation
+
+    This file is part of VirtualBox Open Source Edition (OSE), as
+    available from http://www.virtualbox.org. This file is free software;
+    you can redistribute it and/or modify it under the terms of the GNU
+    General Public License (GPL) as published by the Free Software
+    Foundation, in version 2 as it comes in the "COPYING" file of the
+    VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+    hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
 -->
 