Index: trunk/src/VBox/Main/xml/VirtualBox-settings-common.xsd
===================================================================
--- trunk/src/VBox/Main/xml/VirtualBox-settings-common.xsd	(revision 43105)
+++ trunk/src/VBox/Main/xml/VirtualBox-settings-common.xsd	(revision 43112)
@@ -7,13 +7,13 @@
  *  Common definitions
 
-     Copyright (C) 2004-2012 Oracle Corporation
-
-     This file is part of VirtualBox Open Source Edition (OSE), as
-     available from http://www.virtualbox.org. This file is free software;
-     you can redistribute it and/or modify it under the terms of the GNU
-     General Public License (GPL) as published by the Free Software
-     Foundation, in version 2 as it comes in the "COPYING" file of the
-     VirtualBox OSE distribution. VirtualBox OSE is distributed in the
-     hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+    Copyright (C) 2004-2012 Oracle Corporation
+
+    This file is part of VirtualBox Open Source Edition (OSE), as
+    available from http://www.virtualbox.org. This file is free software;
+    you can redistribute it and/or modify it under the terms of the GNU
+    General Public License (GPL) as published by the Free Software
+    Foundation, in version 2 as it comes in the "COPYING" file of the
+    VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+    hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
 -->
 
@@ -29,5 +29,5 @@
   <xsd:documentation xml:lang="en">
     Oracle VM VirtualBox Settings Schema (common definitions).
-    Copyright (c) 2004-2010 Oracle Corporation
+    Copyright (c) 2004-2012 Oracle Corporation
   </xsd:documentation>
 </xsd:annotation>
Index: trunk/src/VBox/Main/xml/VirtualBox-settings-freebsd.xsd
===================================================================
--- trunk/src/VBox/Main/xml/VirtualBox-settings-freebsd.xsd	(revision 43105)
+++ trunk/src/VBox/Main/xml/VirtualBox-settings-freebsd.xsd	(revision 43112)
@@ -6,13 +6,13 @@
  *  Oracle VM VirtualBox Settings Schema Version 1.0-freebsd
 
-     Copyright (C) 2004-2010 Oracle Corporation
+    Copyright (C) 2004-2010 Oracle Corporation
 
-     This file is part of VirtualBox Open Source Edition (OSE), as
-     available from http://www.virtualbox.org. This file is free software;
-     you can redistribute it and/or modify it under the terms of the GNU
-     General Public License (GPL) as published by the Free Software
-     Foundation, in version 2 as it comes in the "COPYING" file of the
-     VirtualBox OSE distribution. VirtualBox OSE is distributed in the
-     hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+    This file is part of VirtualBox Open Source Edition (OSE), as
+    available from http://www.virtualbox.org. This file is free software;
+    you can redistribute it and/or modify it under the terms of the GNU
+    General Public License (GPL) as published by the Free Software
+    Foundation, in version 2 as it comes in the "COPYING" file of the
+    VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+    hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
 -->
 
Index: trunk/src/VBox/Main/xml/VirtualBox-settings-linux.xsd
===================================================================
--- trunk/src/VBox/Main/xml/VirtualBox-settings-linux.xsd	(revision 43105)
+++ trunk/src/VBox/Main/xml/VirtualBox-settings-linux.xsd	(revision 43112)
@@ -6,13 +6,13 @@
  *  Oracle VM VirtualBox Settings Schema Version 1.0-linux
 
-     Copyright (C) 2004-2010 Oracle Corporation
+    Copyright (C) 2004-2010 Oracle Corporation
 
-     This file is part of VirtualBox Open Source Edition (OSE), as
-     available from http://www.virtualbox.org. This file is free software;
-     you can redistribute it and/or modify it under the terms of the GNU
-     General Public License (GPL) as published by the Free Software
-     Foundation, in version 2 as it comes in the "COPYING" file of the
-     VirtualBox OSE distribution. VirtualBox OSE is distributed in the
-     hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+    This file is part of VirtualBox Open Source Edition (OSE), as
+    available from http://www.virtualbox.org. This file is free software;
+    you can redistribute it and/or modify it under the terms of the GNU
+    General Public License (GPL) as published by the Free Software
+    Foundation, in version 2 as it comes in the "COPYING" file of the
+    VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+    hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
 -->
 
Index: trunk/src/VBox/Main/xml/VirtualBox-settings-macosx.xsd
===================================================================
--- trunk/src/VBox/Main/xml/VirtualBox-settings-macosx.xsd	(revision 43105)
+++ trunk/src/VBox/Main/xml/VirtualBox-settings-macosx.xsd	(revision 43112)
@@ -6,13 +6,13 @@
  *  Oracle VM VirtualBox Settings Schema Version 1.0-macosx
 
-     Copyright (C) 2004-2010 Oracle Corporation
+    Copyright (C) 2004-2010 Oracle Corporation
 
-     This file is part of VirtualBox Open Source Edition (OSE), as
-     available from http://www.virtualbox.org. This file is free software;
-     you can redistribute it and/or modify it under the terms of the GNU
-     General Public License (GPL) as published by the Free Software
-     Foundation, in version 2 as it comes in the "COPYING" file of the
-     VirtualBox OSE distribution. VirtualBox OSE is distributed in the
-     hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+    This file is part of VirtualBox Open Source Edition (OSE), as
+    available from http://www.virtualbox.org. This file is free software;
+    you can redistribute it and/or modify it under the terms of the GNU
+    General Public License (GPL) as published by the Free Software
+    Foundation, in version 2 as it comes in the "COPYING" file of the
+    VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+    hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
 -->
 
Index: trunk/src/VBox/Main/xml/VirtualBox-settings-os2.xsd
===================================================================
--- trunk/src/VBox/Main/xml/VirtualBox-settings-os2.xsd	(revision 43105)
+++ trunk/src/VBox/Main/xml/VirtualBox-settings-os2.xsd	(revision 43112)
@@ -7,13 +7,13 @@
  *  Oracle VM VirtualBox Settings Schema Version 1.0-os2
  *
-     Copyright (C) 2004-2010 Oracle Corporation
+    Copyright (C) 2004-2010 Oracle Corporation
 
-     This file is part of VirtualBox Open Source Edition (OSE), as
-     available from http://www.virtualbox.org. This file is free software;
-     you can redistribute it and/or modify it under the terms of the GNU
-     General Public License (GPL) as published by the Free Software
-     Foundation, in version 2 as it comes in the "COPYING" file of the
-     VirtualBox OSE distribution. VirtualBox OSE is distributed in the
-     hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+    This file is part of VirtualBox Open Source Edition (OSE), as
+    available from http://www.virtualbox.org. This file is free software;
+    you can redistribute it and/or modify it under the terms of the GNU
+    General Public License (GPL) as published by the Free Software
+    Foundation, in version 2 as it comes in the "COPYING" file of the
+    VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+    hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
 -->
 
Index: trunk/src/VBox/Main/xml/VirtualBox-settings-solaris.xsd
===================================================================
--- trunk/src/VBox/Main/xml/VirtualBox-settings-solaris.xsd	(revision 43105)
+++ trunk/src/VBox/Main/xml/VirtualBox-settings-solaris.xsd	(revision 43112)
@@ -6,13 +6,13 @@
  *  Oracle VM VirtualBox Settings Schema Version 1.0-solaris
 
-     Copyright (C) 2004-2010 Oracle Corporation
+    Copyright (C) 2004-2010 Oracle Corporation
 
-     This file is part of VirtualBox Open Source Edition (OSE), as
-     available from http://www.virtualbox.org. This file is free software;
-     you can redistribute it and/or modify it under the terms of the GNU
-     General Public License (GPL) as published by the Free Software
-     Foundation, in version 2 as it comes in the "COPYING" file of the
-     VirtualBox OSE distribution. VirtualBox OSE is distributed in the
-     hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+    This file is part of VirtualBox Open Source Edition (OSE), as
+    available from http://www.virtualbox.org. This file is free software;
+    you can redistribute it and/or modify it under the terms of the GNU
+    General Public License (GPL) as published by the Free Software
+    Foundation, in version 2 as it comes in the "COPYING" file of the
+    VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+    hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
 -->
 
Index: trunk/src/VBox/Main/xml/VirtualBox-settings-windows.xsd
===================================================================
--- trunk/src/VBox/Main/xml/VirtualBox-settings-windows.xsd	(revision 43105)
+++ trunk/src/VBox/Main/xml/VirtualBox-settings-windows.xsd	(revision 43112)
@@ -6,13 +6,13 @@
  *  Oracle VM VirtualBox Settings Schema Version 1.0-windows
 
-     Copyright (C) 2004-2010 Oracle Corporation
+    Copyright (C) 2004-2010 Oracle Corporation
 
-     This file is part of VirtualBox Open Source Edition (OSE), as
-     available from http://www.virtualbox.org. This file is free software;
-     you can redistribute it and/or modify it under the terms of the GNU
-     General Public License (GPL) as published by the Free Software
-     Foundation, in version 2 as it comes in the "COPYING" file of the
-     VirtualBox OSE distribution. VirtualBox OSE is distributed in the
-     hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+    This file is part of VirtualBox Open Source Edition (OSE), as
+    available from http://www.virtualbox.org. This file is free software;
+    you can redistribute it and/or modify it under the terms of the GNU
+    General Public License (GPL) as published by the Free Software
+    Foundation, in version 2 as it comes in the "COPYING" file of the
+    VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+    hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
 -->
 